package com.rshka.mcs.services;

import static org.junit.Assert.assertNotNull;

import javax.ws.rs.ext.ExceptionMapper;

import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.Matchers;
import org.mockito.Mock;
import org.mockito.Mockito;
import org.mockito.runners.MockitoJUnitRunner;
import org.springframework.dao.EmptyResultDataAccessException;

import com.rshka.mcs.beans.Customer;
import com.rshka.mcs.dao.CustomerDaoImpl;
import com.rshka.mcs.service.CustomerServiceImpl;
import static com.rshka.mcs.utils.TestUtils.getCustomerByDocument;

@RunWith(MockitoJUnitRunner.class)
public class CustomerServiceImplTest {

	@InjectMocks
	CustomerServiceImpl customerServiceImpl;

	@Mock
	private CustomerDaoImpl customerDaoImpl;
	
	@Rule
	public ExpectedException thrown = ExpectedException.none();

	public CustomerServiceImplTest() {
	}

	@Test
	public void testGetCustomerOk() {

		Mockito.when(this.customerDaoImpl.getCustomer(Mockito.anyString())).thenReturn(getCustomerByDocument());

		this.customerServiceImpl = new CustomerServiceImpl(customerDaoImpl);

		Customer customer = this.customerServiceImpl.getCustomer(Mockito.anyString());

		assertNotNull(customer);

	}
	
	@Test
	public void testGetCustomerNotOk() {

		this.customerServiceImpl = new CustomerServiceImpl(customerDaoImpl);

		Mockito.when(this.customerDaoImpl.getCustomer(Mockito.anyString())).thenThrow(new EmptyResultDataAccessException("Cannot find customer", 1));

		EmptyResultDataAccessException expectedException = new EmptyResultDataAccessException("Cannot find customer", 1);
		
		thrown.expect(EmptyResultDataAccessException.class);
		
		Customer customer = this.customerServiceImpl.getCustomer(Mockito.anyString());


	}

}